/***********************************************************************/
/*                                                                     */
/*  FILE        :Timer_drv.c                                           */
/*  DATE        :Tue, Oct 17, 2010                                     */
/*  DESCRIPTION :Timer Function			                               */
/*  CPU TYPE    :H8SX/1655                                             */
/*                                                                     */
/*  Created		:Yoshikazu Morita (d:Frontia)                          */
/*  Modified	:													   */
/***********************************************************************/
#include "iodefine.h"
#include "typedefine.h"
#include "Timer_Drv.h"

#ifdef __cplusplus
extern "C" {
#endif
extern void Timer_Initalize(void);
#ifdef __cplusplus
}
#endif

_UINT Freq_Pointer = 0;
_UINT Freq_Sample_Count = 0;

_UDWORD Freq_Sample_Buffer[FREQ_BUFFER_MAX];
_UDWORD Freq_Diff_Buffer[FREQ_BUFFER_MAX];


//w~b҂ 1񓖂肨悻Pʕbij
//p^[O1ʕb
void WaitTime(long time)
{
	PA.DR.BIT.B0 = 1;
	while( time -- > 0 )
	{
	
		// 1usec𐳊mɒ~(IVXR[vŌvj(500usecŌvj
		// 
		__asm{
			push.w		r0			// 6 A
			mov.w		#8,r0		// 4 A
		waitLoop:					
			dec.w		#1,r0		// 2 B
			and.w		r0,r0		// 2 B
			bne			waitLoop	// 4 B
			pop.w		r0			// 6 A
		}
	}
	PA.DR.BIT.B0 = 0;
}


//^C}[̏
void Timer_Initalize(void)
{
	//16bit TimerW[(TPU)𓮍삳B
	MSTP.CRA.BIT._TPU 	= 0;	//ԂTPUW[͒~ĂB

	//Ch4Ch5̂QTPU^C}𗘗pāAgv܂B
	//Ch4Ch5̓JXP[hڑāACh416bit Ch516bitōv32rbgœ삵܂B
	//NbŃAP/1𗘗p12MHz̕\܂B
	//TIOCA4/5ŌgATICOB4/5ŃtB^g`Ƃ̈ʑ𓾂܂B
	//㒼Ɏǧv͊JnA}CR쒆͌v܂B

	//Ch4 Timeȑ
	TPU4.TCR.BIT.CCLR = 1;		//TGRA ̃CvbgLv`TCNT NA
	TPU4.TCR.BIT.TPSC = 7;		//TCNT5*̃I[ot[^A_t[ŃJEg
	TPU4.TMDR.BIT.MD = 0;		//ʏ퓮
	TPU4.TIOR.BIT.IOB = 8;		//Lv`͌TIOCB4 [q オGbWŃCvbgLv`
	TPU4.TIOR.BIT.IOA = 8;		//Lv`͌TIOCA4 [q オGbWŃCvbgLv`
	P2.DDR = 0x0A;				//TIOCB4 input
	P2.ICR.BIT.B4 = 1;			//̓obt@L
	P2.ICR.BIT.B5 = 1;			//̓obt@L

	//Ch5 Timeȑ
	TPU5.TCR.BIT.CCLR = 1;		//TGRA ̃CvbgLv`TCNT NA
	TPU5.TCR.BIT.CKEG = 2;		//GbWŃJEg
	TPU5.TCR.BIT.TPSC = 0;		//NbNFP/1 ŃJEg = (24MHz)
	TPU5.TMDR.BIT.MD = 0;		//ʏ퓮
	TPU5.TIOR.BIT.IOB = 8;		//Lv`͌TIOCB5 [q オGbWŃCvbgLv`
	TPU5.TIOR.BIT.IOA = 8;		//Lv`͌TIOCA5 [q オGbWŃCvbgLv`
	P2.ICR.BIT.B6 = 1;			//̓obt@L
	P2.ICR.BIT.B7 = 1;			//̓obt@L
	
	TPU.TSTR.BYTE = 0x30;		//Timer4,Timer5 TCNT쓮Jn
	
	//USBʐM̃R}h󂯂āA
	//gvobt@NAB
	//gZbgォ͂ĂƁA
	//̌vCPUp[DāAPlag&PlayɎsׁB
	//Reset_FreqSampling_Buffer();
}	


//TGI4A
//gv1񕪊
//v1񕪊̂ŁAgvobt@֌vʂi[B
void Freq_Chaptered_Int( void )
{
	long PH0;
	long PH1_Diff;
	int flag;
	
	if( TPU4.TSR.BIT.TGFA == 1 )
	{
		PA.DR.BIT.B2 = 1;
	
		TPU4.TSR.BIT.TGFA = 0;
	
		PH0 = ((long)(TPU4.TGRA) << 16) + TPU5.TGRA;
		PH1_Diff = ((long)(TPU4.TGRB) << 16) + TPU5.TGRB;


		Freq_Sample_Buffer[Freq_Pointer] = PH0;
		Freq_Diff_Buffer[Freq_Pointer] = PH1_Diff;
	
		Freq_Pointer++;

		//obt@ςɂȂvIB
		//g^ƁÅݏCPUp[̑唼߂Ă܂
		//USBʐMsʂɂȂĂ܂߁B
		if( Freq_Pointer == FREQ_BUFFER_MAX )
		{
			TPU4.TIER.BIT.TGIEA = 0;	//TGR4Åݏ֎~B
		}
		if( Freq_Sample_Count < FREQ_BUFFER_MAX )
		{
			Freq_Sample_Count++;
		}
		PA.DR.BIT.B2 = 0;
	}
}

//gvobt@NA
//Ȏg̑JnۂɗpB
void Reset_FreqSampling_Buffer( void )
{
	//obt@̃CfbNX̂
	Freq_Pointer = 0;
	Freq_Sample_Count = 0;

	//ݏJnBiݗvƂ
	TPU4.TSR.BIT.TGFA = 0;
	TPU4.TIER.BIT.TGIEA = 1;	//TGR4ÅݏB
}
